#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartFTP  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartFTPWrap.h SmartFTPWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartFTPCore.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


typedef void (*SetConnectInfoEx)(LPTSTR strFtpAddress, unsigned int iPortNo, LPTSTR strUserID, LPTSTR strPassword, BOOL bPassiveMode);
typedef BOOL (*ConnectEx)();
typedef BOOL (*DisConnectEx)();
typedef BOOL (*SetRootDirectoryEx)();
typedef BOOL (*SetCurrentDirectoryEx)(LPTSTR strPath);
typedef BOOL (*GetCurrentDirectoryEx)(LPTSTR strPath);
typedef BOOL (*CreateFolderEx)(LPTSTR strFolderName);
typedef BOOL (*DeleteFolderEx)(LPTSTR strFolderName);
typedef BOOL (*DeleteFilesEx)(LPTSTR strFileName);
typedef BOOL (*ReNameEx)(LPTSTR strOldName, LPTSTR strNewName);
typedef BOOL (*FileDownloadEx)(LPTSTR strFTPFilePathName, LPTSTR strLocalFilePathName);
typedef BOOL (*FileUploadEx)(LPTSTR strLocalFilePathName, LPTSTR strFTPFilePathName);
typedef BOOL (*GetFileListEx)(LPTSTR strRetList);
typedef int (*GetPercentageEx)();
typedef void (*FileUpNDownloadCancelEx)();


class CSmartFTPWrap
{
private:
	HINSTANCE						m_hInst;

	SetConnectInfoEx				m_pfSetConnectInfo;
	ConnectEx						m_pfConnect;
	DisConnectEx					m_pfDisConnect;
	SetRootDirectoryEx				m_pfSetRootDirectory;
	SetCurrentDirectoryEx			m_pfSetCurrentDirectory;
	GetCurrentDirectoryEx			m_pfGetCurrentDirectory;
	CreateFolderEx					m_pfCreateFolder;
	DeleteFolderEx					m_pfDeleteFolder;
	DeleteFilesEx					m_pfDeleteFiles;
	ReNameEx						m_pfReName;
	FileDownloadEx					m_pfFileDownload;
	FileUploadEx					m_pfFileUpload;
	GetFileListEx					m_pfGetFileList;
	GetPercentageEx					m_pfGetPercentage;
	FileUpNDownloadCancelEx			m_pfFileUpNDownloadCancel;

public:
	CSmartFTPWrap(void);
	~CSmartFTPWrap(void);

	void SetConnectInfo(LPTSTR strFtpAddress, unsigned int iPortNo, LPTSTR strUserID, LPTSTR strPassword, BOOL bPassiveMode);
	BOOL Connect();
	BOOL DisConnect();
	BOOL SetRootDirectory();
	BOOL SetCurrentDirectory(LPTSTR strPath);
	BOOL GetCurrentDirectory(LPTSTR strPath);
	BOOL CreateFolder(LPTSTR strFolderName);
	BOOL DeleteFolder(LPTSTR strFolderName);
	BOOL DeleteFiles(LPTSTR strFileName);
	BOOL ReName(LPTSTR strOldName, LPTSTR strNewName);
	BOOL FileDownload(LPTSTR strFTPFilePathName, LPTSTR strLocalFilePathName);
	BOOL FileUpload(LPTSTR strLocalFilePathName, LPTSTR strFTPFilePathName);
	BOOL GetFileList(LPTSTR strRetList);
	int GetPercentage();
	void FileUpNDownloadCancel();
};
